<?xml version="1.0" encoding="utf-8"?>

<!DOCTYPE xsl:stylesheet [ 
<!ENTITY nbsp "&#160;"> 
<!ENTITY mdash "&#8212;">
]>

<xsl:stylesheet
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.1"
  xmlns:func="http://exslt.org/functions"
  xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
  xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
  xmlns="http://www.w3.org/2000/svg"
  xmlns:ink-r="org.inkscape.xslt.files"
  xmlns:ink="http://www.inkscape.org/namespaces/xslt"
  xmlns:xlink="http://www.w3.org/1999/xlink"
  exclude-result-prefixes="func ink-r xsl"
  extension-element-prefixes="func ink-r ink"
>

<xsl:output method="xml" encoding="utf-8" indent="no"/>

<!-- parameters and variables -->
<xsl:param name="ill-path"/>
<xsl:param name="ink-path"/>
<xsl:param name="language">en</xsl:param>

<xsl:variable name="font-sans">Liberation Sans,Arial,sans-serif</xsl:variable>
<xsl:variable name="font-serif">Liberation Serif,Times New Roman,serif</xsl:variable>
<xsl:variable name="font-monospace">Liberation Mono,Lucida Console,Consolas,monospace</xsl:variable>

<xsl:variable name="normal-style">
  <xsl:value-of select="concat('font-size:8;line-height:133%;font-family:', $font-serif)"/>
</xsl:variable>

<xsl:variable name="parskip">10</xsl:variable>
<xsl:variable name="abstract-parskip">6</xsl:variable>
<xsl:variable name="imageskip-before">8</xsl:variable>
<xsl:variable name="imageskip-after">12</xsl:variable>

<xsl:variable name="column-width">300</xsl:variable>
<xsl:variable name="abstract-column-width">264</xsl:variable>
<xsl:variable name="item-column-width">258</xsl:variable>

<xsl:variable name="left-margin">10</xsl:variable>
<xsl:variable name="abstract-left-margin">35</xsl:variable>
<xsl:variable name="item-left-margin">20</xsl:variable>
<xsl:variable name="image-left-margin">10</xsl:variable>

<xsl:variable name="head-fs">8</xsl:variable>
<xsl:variable name="head2-fs">7.5</xsl:variable>
<xsl:variable name="abstract-fs">7.2</xsl:variable>

<xsl:variable name="id" select="generate-id()"/>

<xsl:variable name="header-filename">
  <xsl:choose>
    <xsl:when test="$language = 'en'">_tutorial-header.svg</xsl:when>
    <xsl:otherwise>
      <xsl:choose>
        <xsl:when test="ink-r:exists(concat('_tutorial-header.', $language, '.svg'))"><xsl:value-of select="concat('_tutorial-header.', $language, '.svg')"/></xsl:when>
        <xsl:otherwise>_tutorial-header.svg</xsl:otherwise>
      </xsl:choose>
    </xsl:otherwise>
  </xsl:choose>
</xsl:variable>

<xsl:variable name="footer-filename">
  <xsl:choose>
    <xsl:when test="$language = 'en'">_tutorial-footer.svg</xsl:when>
    <xsl:otherwise>
      <xsl:choose>
        <xsl:when test="ink-r:exists(concat('_tutorial-footer.', $language, '.svg'))"><xsl:value-of select="concat('_tutorial-footer.', $language, '.svg')"/></xsl:when>
        <xsl:otherwise>_tutorial-footer.svg</xsl:otherwise>
      </xsl:choose>
    </xsl:otherwise>
  </xsl:choose>
</xsl:variable>

<xsl:variable name="y" select="ink-r:set-variable('y', 36)"/>

<!-- custom functions -->
<func:function name="ink:normalize-without-trimming">
  <xsl:param name="string"/>
  <func:result>
    <xsl:value-of select="substring(normalize-space(concat('.',$string,'.')), 2, string-length(normalize-space(concat('.',$string,'.'))) - 2)"/> 
  </func:result>
</func:function>

<func:function name="ink:strip-leading-whitespace">
  <xsl:param name="string"/>
  <func:result>
    <xsl:choose>
      <xsl:when test="starts-with($string, ' ') or starts-with($string, '&#xD;') or starts-with($string, '&#xA;')">
        <xsl:value-of select="ink:strip-leading-whitespace(substring($string, 2, string-length(.)))"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$string"/>
      </xsl:otherwise>
    </xsl:choose>  
  </func:result>
</func:function>

<func:function name="ink:prefixize">
  <xsl:param name="prefix"/>
  <xsl:param name="string"/>
  <func:result>
    <xsl:choose>
      <xsl:when test="contains($string, 'url(#')">
        <xsl:value-of select="concat(substring-before($string, 'url(#'), 'url(#', $prefix, ink:prefixize($prefix, substring-after($string, 'url(#')))"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$string"/>
      </xsl:otherwise>
    </xsl:choose>
  </func:result>
</func:function>

<!-- page skeleton -->
<xsl:template match="/">
  <xsl:comment> DO NOT EDIT THIS FILE. It is produced automatically from a DocBook source (*.xml) by tutorial-svg.xsl. </xsl:comment>
  <svg
      xmlns:xml="http://www.w3.org/XML/1998/namespace"
      xmlns:dc="http://purl.org/dc/elements/1.1/"
      xmlns:cc="http://web.resource.org/cc/"
      xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
      xmlns:svg="http://www.w3.org/2000/svg"
      xmlns="http://www.w3.org/2000/svg"
      xmlns:xlink="http://www.w3.org/1999/xlink"
      xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
      xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
      id="svg1"
      version="1.1"
      sodipodi:version="0.32"
      inkscape:version="0.92"
      width="256pt"
      height="256pt"
      sodipodi:docname="tutorial-basic.svg">
    <sodipodi:namedview
        id="base"
        inkscape:zoom="2"
        inkscape:cx="160"
        inkscape:cy="170"
        inkscape:window-width="780"
        inkscape:window-height="580"
        inkscape:window-x="0"
        inkscape:window-y="0"
        showborder="false"
        showguides="true"
        snaptoguides="true"/>

    <!-- header -->
    <xsl:for-each select="document($header-filename)/*/*[name() != 'sodipodi:namedview']"> 
      <xsl:copy-of select="."/>
    </xsl:for-each>

    <!-- title -->
    <text
        style="font-size:7;font-family:{$font-sans};fill:#ffffff"
        x="{$abstract-left-margin}"
        y="30"
        id="text1920"
        transform="scale(1.130730,1.130730)"><tspan
          id="tspan1668"
          dx="0 -0.57057059 0 0 0 0 0"
          style="letter-spacing:2.1813099;fill:#ffffff;fill-opacity:1">::<xsl:value-of select="ink-r:upper-case(string(book/chapter/title))"/></tspan></text>
    <xsl:variable name="y" select="ink-r:set-variable('y', $y + $parskip)"/>

    <!-- body content -->
    <xsl:apply-templates/>

    <!-- footer -->
    <xsl:variable name="y2" select="ink-r:get-variable('y')"/>
    <g transform="translate(0, {$y2})">
      <xsl:for-each select="document($footer-filename)/*/*[name() != 'sodipodi:namedview']"> 
        <xsl:copy-of select="."/>
      </xsl:for-each>
    </g>

    <!-- cleanup -->
    <xsl:variable name="dummy" select="ink-r:run('rm', concat('para-query-', generate-id(), '.svg'))"/>
  </svg>
</xsl:template>

<!-- helper templates for prefixing: mode="reid" -->
<xsl:template match="@*" mode="reid">
  <xsl:param name="prefix"/>
  <xsl:choose>
    <xsl:when test="name()='id'">
      <xsl:attribute name="{name()}">
        <xsl:value-of select="concat($prefix, .)"/>
      </xsl:attribute>
    </xsl:when>
    <xsl:when test="name()='xlink:href'">
      <xsl:attribute name="{name()}">
        <xsl:choose>
          <xsl:when test="starts-with(., '#')">
            <xsl:value-of select="concat('#', $prefix, substring-after(., '#'))"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="."/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:attribute>
    </xsl:when>
    <xsl:when test="name()='inkscape:href'">
      <xsl:attribute name="{name()}">
        <xsl:choose>
          <xsl:when test="starts-with(., '#')">
            <xsl:value-of select="concat('#', $prefix, substring-after(., '#'))"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="."/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:attribute>
    </xsl:when>
    <xsl:otherwise>
      <xsl:attribute name="{name()}">
        <xsl:value-of select="ink:prefixize($prefix, .)"/>
      </xsl:attribute>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>

<xsl:template match="*" mode="reid">
  <xsl:param name="prefix"/>
  <xsl:element name="{name()}">
    <xsl:apply-templates mode="reid" select="@*">
      <xsl:with-param name="prefix" select="$prefix"/>
    </xsl:apply-templates>
    <xsl:apply-templates mode="reid" select="*|text()">
      <xsl:with-param name="prefix" select="$prefix"/>
    </xsl:apply-templates>
  </xsl:element>
</xsl:template>

<xsl:template match="text()" mode="reid">
  <xsl:param name="prefix"/>
  <xsl:copy/>
</xsl:template>

<!-- helper templates for getting height of an element: mode="height" -->
<xsl:template match="abstract/para" mode="height">
  <xsl:document href="para-query-{$id}.svg" encoding="utf-8" method="xml" omit-xml-declaration="yes" indent="yes">
    <svg width="1600px" height="400px">
      <rect id="rectID" width="{$abstract-column-width}" height="1000px" x="{$abstract-left-margin}" y="0px" style="fill:none"/>
      <flowRoot
          id="flowRootID" style="font-size:{$abstract-fs};font-style:italic;line-height:150%;font-family:{$font-sans}">
        <flowRegion>
          <use
              xlink:href="#rectID"
              y="0"
              x="0" />
        </flowRegion>
        <flowDiv xml:space="preserve"><xsl:apply-templates/></flowDiv></flowRoot>
    </svg>
  </xsl:document>
  <xsl:value-of select="ink-r:run-shell($ink-path, concat('para-query-', $id, '.svg --query-height --query-id flowRootID'))"/>
</xsl:template>

<xsl:template match="sect1/para|sect2/para|chapter/para" mode="height">
  <xsl:document href="para-query-{$id}.svg" encoding="utf-8" method="xml" omit-xml-declaration="yes" indent="yes">
    <svg width="1600px" height="400px">
      <rect id="rectID" width="{$column-width}" height="1000px" x="{$left-margin}" y="0px" style="fill:none"/>
      <flowRoot
          id="flowRootID" style="{$normal-style}">
        <flowRegion>
          <use
              xlink:href="#rectID"
              y="0"
              x="0" />
        </flowRegion>
        <flowDiv xml:space="preserve"><xsl:apply-templates/></flowDiv></flowRoot>
    </svg>
  </xsl:document>
  <xsl:value-of select="ink-r:run-shell($ink-path, concat('para-query-', $id, '.svg --query-height --query-id flowRootID'))"/>
</xsl:template>

<xsl:template match="listitem/para" mode="height">
  <xsl:document href="para-query-{$id}.svg" encoding="utf-8" method="xml" omit-xml-declaration="yes" indent="yes">
    <svg width="1600px" height="400px">
      <rect id="rectID" width="{$item-column-width}" height="1000px" x="{$item-left-margin}" y="0px" style="fill:none"/>
      <flowRoot
          id="flowRootID" style="{$normal-style}">
        <flowRegion>
          <use
              xlink:href="#rectID"
              y="0"
              x="0" />
        </flowRegion>
        <flowDiv xml:space="preserve"><xsl:apply-templates/></flowDiv></flowRoot>
    </svg>
  </xsl:document>
  <xsl:value-of select="ink-r:run-shell($ink-path, concat('para-query-', $id, '.svg --query-height --query-id flowRootID'))"/>
</xsl:template>

<!-- templates for text nodes, mostly whitespaces -->
<xsl:template match="para/text()">
  <xsl:value-of select="ink:normalize-without-trimming(.)"/>
</xsl:template>

<xsl:template match="para/text()[1][starts-with(.,'&#10;')]">
  <xsl:value-of select="ink:strip-leading-whitespace(.)"/>
</xsl:template>

<!-- templates for individual elements -->
<xsl:template match="chapter/title"/>

<xsl:template match="chapterinfo">
  <xsl:comment>Author: <xsl:for-each select="//author"> <xsl:value-of select="./firstname"/>&nbsp;<xsl:value-of select="./surname"/>,  <xsl:value-of select="./email"/>&nbsp;</xsl:for-each></xsl:comment>
</xsl:template>

<xsl:template match="sect1/title">
  <xsl:variable name="y" select="ink-r:get-variable('y')"/>
  <text
      style="font-size:{$head-fs};font-style:normal;font-weight:bold;fill:#000000;fill-opacity:1;stroke:none;font-family:{$font-sans}"
      x="{$left-margin}"
      y="{$y + 1.6*$head-fs}"><tspan
        x="{$left-margin}"
        y="{$y + 1.6*$head-fs}"
        ><xsl:apply-templates/></tspan></text>
  <xsl:variable name="y_new" select="ink-r:set-variable('y', $y + $head-fs + $parskip)"/>
</xsl:template>

<xsl:template match="sect2/title">
  <xsl:variable name="y" select="ink-r:get-variable('y')"/>
  <text
      style="font-size:{$head2-fs};font-style:italic;font-weight:bold;font-family:{$font-sans};"
      x="{$left-margin}"
      y="{$y + 1.6*$head2-fs}"><tspan
        x="{$left-margin}"
        y="{$y + 1.6*$head2-fs}"
        ><xsl:apply-templates/></tspan></text>
  <xsl:variable name="y_new" select="ink-r:set-variable('y', $y + $head2-fs + $parskip)"/>
</xsl:template>

<xsl:template match="abstract">
  <xsl:variable name="y" select="ink-r:set-variable('y', $y + $abstract-parskip)"/>
  <xsl:apply-templates/>
</xsl:template>

<xsl:template match="abstract/para">
  <xsl:variable name="y" select="ink-r:get-variable('y')"/>
  <rect id="{generate-id()}" width="{$abstract-column-width}" height="1000px" x="{$abstract-left-margin}" y="{$y}" style="display:none"/>
  <flowRoot
      style="font-size:{$abstract-fs};font-style:italic;line-height:150%;font-family:{$font-sans}">
    <flowRegion>
      <use
          xlink:href="#{generate-id()}"
          y="0"
          x="0" />
    </flowRegion>
    <flowDiv xml:space="preserve"><xsl:apply-templates/></flowDiv></flowRoot>
  <xsl:variable name="current-h"><xsl:apply-templates select="." mode="height"/></xsl:variable>
  <xsl:variable name="y_new" select="ink-r:set-variable('y', $y + $current-h + $abstract-parskip)"/>
</xsl:template>

<xsl:template match="sect1/para|sect2/para|chapter/para">
  <xsl:variable name="y" select="ink-r:get-variable('y')"/>
  <rect id="{generate-id()}" width="{$column-width}" height="1000px" x="{$left-margin}" y="{$y}" style="display:none"/>
  <flowRoot
      style="{$normal-style}">
    <flowRegion>
      <use
          xlink:href="#{generate-id()}"
          y="0"
          x="0" />
    </flowRegion>
    <flowDiv xml:space="preserve"><xsl:apply-templates/></flowDiv></flowRoot>
  <xsl:variable name="current-h"><xsl:apply-templates select="." mode="height"/></xsl:variable>
  <xsl:variable name="y_new" select="ink-r:set-variable('y', $y + $current-h + $parskip)"/>
</xsl:template>

<xsl:template match="listitem/para">
  <xsl:variable name="y" select="ink-r:get-variable('y')"/>
  <circle cx="0" cy="0" r="2" transform="translate({$item-left-margin - 5}, {$y + 6})"/>
  <rect id="{generate-id()}" width="{$item-column-width}" height="1000px" x="{$item-left-margin}" y="{$y}" style="display:none"/>
  <flowRoot style="{$normal-style}">
    <flowRegion>
      <use
          xlink:href="#{generate-id()}"
          y="0" x="0" />
    </flowRegion>
    <flowDiv xml:space="preserve"><xsl:apply-templates/></flowDiv></flowRoot>
  <xsl:variable name="current-h"><xsl:apply-templates select="." mode="height"/></xsl:variable>
  <xsl:variable name="y_new" select="ink-r:set-variable('y', $y + $current-h + $parskip)"/>
</xsl:template>

<xsl:template match="keycombo">
  <xsl:for-each select="keycap|mousebutton">
    <xsl:apply-templates select="."/>
    <xsl:choose>
      <xsl:when test="position() != last()">+</xsl:when>
    </xsl:choose>
  </xsl:for-each>
</xsl:template>

<xsl:template match="keycap">
  <xsl:choose>
    <!-- target values: Ctrl, Left Ctrl, Right Ctrl, Alt, Left Alt, Right Alt, Shift -->
    <xsl:when test="@function='control' or @function='shift' or @function='alt'">
      <flowSpan style="font-weight:bold"><xsl:value-of select="text()"/></flowSpan>
    </xsl:when>
    <xsl:otherwise>
      <flowSpan style="font-weight:bold"><xsl:value-of select="text()"/></flowSpan>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>

<xsl:template match="mousebutton">
  <!-- TODO {@role} -->
  <flowSpan style="font-weight:bold"><xsl:value-of select="text()"/></flowSpan>
</xsl:template>

<xsl:template match="guimenu">
  <flowSpan style="font-family:{$font-sans}" fill="#6495ED"><xsl:apply-templates/></flowSpan>
</xsl:template>

<xsl:template match="guisubmenu">
  <flowSpan style="font-family:{$font-sans}" fill="#6495ED"><xsl:apply-templates/></flowSpan>
</xsl:template>

<xsl:template match="guimenuitem">
  <flowSpan style="font-family:{$font-sans}" fill="#6495ED"><xsl:apply-templates/></flowSpan>
</xsl:template>

<xsl:template match="menuchoice">
  <xsl:for-each select="guimenu|guisubmenu|guimenuitem">
    <xsl:apply-templates select="."/>
    <xsl:choose>
      <xsl:when test="position() != last()">⇒</xsl:when>
    </xsl:choose>
  </xsl:for-each>
</xsl:template>

<xsl:template match="guibutton">
  <flowSpan style="font-family:{$font-sans}"><xsl:apply-templates/></flowSpan>
</xsl:template>

<xsl:template match="guilabel">
  <flowSpan style="font-family:{$font-sans}"><xsl:apply-templates/></flowSpan>
</xsl:template>

<xsl:template match="emphasis">
  <flowSpan style="font-style:italic"><xsl:apply-templates/></flowSpan>
</xsl:template>

<xsl:template match="firstterm">
  <flowSpan style="font-style:italic"><xsl:apply-templates/></flowSpan>
</xsl:template>

<xsl:template match="command">
  <flowSpan style="font-family:{$font-monospace}"><xsl:apply-templates/></flowSpan>
</xsl:template>

<xsl:template match="code">
  <flowSpan style="font-family:{$font-monospace}"><xsl:apply-templates/></flowSpan>
</xsl:template>

<xsl:template match="ulink">
  <flowSpan style="font-weight:bold; font-family:{$font-sans}"><xsl:apply-templates/></flowSpan>
</xsl:template>

<xsl:template match="informalfigure">
  <xsl:variable name="y2" select="ink-r:get-variable('y')"/>
  <xsl:variable name="y" select="ink-r:set-variable('y', $y2 + $imageskip-before)"/>

  <xsl:variable name="filename" select="mediaobject/imageobject/imagedata/@fileref"/>
  <xsl:variable name="filename_stripped" select="substring-before($filename, '.')"/>
  <xsl:variable name="filename_localized">
    <xsl:choose>
      <xsl:when test="$language = 'en'"><xsl:value-of select="$filename"/></xsl:when>
      <xsl:otherwise>
        <xsl:choose>
          <xsl:when test="ink-r:exists(concat($ill-path, $filename_stripped, '-', $language, '.svg'))"><xsl:value-of select="concat($filename_stripped, '-', $language, '.svg')"/></xsl:when>
          <xsl:otherwise><xsl:value-of select="$filename"/></xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:variable>

  <xsl:if test="document(concat($ill-path, $filename_localized))/*/*[name()='defs']/*">
    <xsl:apply-templates mode="reid" select="document(concat($ill-path, $filename_localized))/*/*[name()='defs']">
      <xsl:with-param name="prefix" select="$filename_localized"/>
    </xsl:apply-templates>
  </xsl:if>

  <xsl:for-each select="document(concat($ill-path, $filename_localized))/*/*[@inkscape:groupmode='layer']/*"> 
    <xsl:variable name="old_t" select="@transform"/>
    <xsl:copy>
      <xsl:choose>
        <xsl:when test="not(name()='use') and not(@sodipodi:type='inkscape:offset')">
          <xsl:attribute name="transform"><xsl:value-of select="concat('translate(', $image-left-margin, ', ', $y, ')',  ' ',  $old_t)"/></xsl:attribute>
        </xsl:when>
        <xsl:otherwise>
          <xsl:attribute name="transform"><xsl:value-of select="concat('translate(', $image-left-margin, ', ', $y, ')',  ' ',  $old_t, ' translate(', -$image-left-margin, ', ', -$y, ')')"/></xsl:attribute>
        </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates mode="reid" select="@*[name()!='transform']">
        <xsl:with-param name="prefix" select="$filename_localized"/>
      </xsl:apply-templates>
      <xsl:apply-templates mode="reid" select="*|text()">
        <xsl:with-param name="prefix" select="$filename_localized"/>
      </xsl:apply-templates>
    </xsl:copy>
  </xsl:for-each>

  <xsl:variable name="current-h"><xsl:value-of select="ink-r:run-shell($ink-path, concat($ill-path, $filename_localized, ' --query-height'))"/></xsl:variable>
  <xsl:variable name="y_new" select="ink-r:set-variable('y', $y + $current-h + $imageskip-after)"/>
</xsl:template>

</xsl:stylesheet>
